#ifndef CIIMAGE_H
#define CIIMAGE_H

#import <Foundation/NSObject.h>
#import <ApplicationServices/ApplicationServices.h>
#import <QuartzCore/CVImageBuffer.h>
#include <HYS/QuartzCore/CIImage.h>

@interface CIImage
{
    
}
/*extent

Gets the extent of an image.

- (CGRect)extent
Return Value

A rectangle that specifies the extent of the image in working space coordinates.
Availability
Mac OS X v10.4 and later.*/
- (CGRect)extent;

/*imageWithCVImageBuffer:

Creates an image object from the contents of CVImageBuffer object.

+ (CIImage *)imageWithCVImageBuffer:(CVImageBufferRef)imageBuffer
Parameters
imageBuffer

A CVImageBuffer object. For more information, see Core Video Programming Guide and Core Video Reference.
Return Value

An image object initialized with the contents of the CVImageBuffer object.
Availability
Mac OS X v10.4 and later.*/
+ (CIImage *)imageWithCVImageBuffer:(CVImageBufferRef)imageBuffer;

@end


#endif
