#import <Cocoa/Cocoa.h>
#import <QuickTime/QuickTime.h>
#import <QTKit/QTKit.h>
//#import <QTKit/QTTime.h>
//#import <QTKit/QTTimeRange.h>
//#import <QTKit/QTMovie.h>

@implementation QTMovie



/*initWithFile:error:

- (id)initWithFile:(NSString *)fileName error:(NSError **)errorPtr
Discussion

Initializes a QTMovie object with the data in the file specified by the name fileName. The fileName is assumed to be a full path name for a file. If a QTMovie object cannot be created, an NSError object is returned in the location pointed to by errorPtr. Pass NIL if you do not want an NSError object returned.

Note that alias files should not be passed into this method; the client application is responsible for resolving aliases before handing them to QTKit methods.
Availability
Available in Mac OS X v10.3 and later.*/
- (id)initWithFile:(NSString *)fileName error:(NSError **)errorPtr
 {
}

/*setAttribute:forKey:

- (void)setAttribute:(id)value forKey:(NS String *)attributeKey
Discussion

Set the movie attribute attributeKey to the value specified by the value parameter. A list of supported movie attributes and their acceptable values can be found in the “Constants” section.
Availability
Available in Mac OS X v10.3 and later.*/

- (void) setAttribute: (id)value forKey: (NSString *)attributeKey
 {
//TODO
}

/*quickTimeMovie

- (Movie)quickTimeMovie
Discussion

Returns the QuickTime movie associated with a QTMovie object.
Availability
Available in Mac OS X v10.3 and later.
See Also
– quickTimeMovieController*/
- (Movie)quickTimeMovie{
//TODO
}

/*attributeForKey:

- (id)attributeForKey:(NSString *)attributeKey
Discussion

Returns the current value of the movie attribute attributeKey. A list of supported movie attributes and their acceptable values can be found in the “Constants” section.
Availability
Available in Mac OS X v10.3 and later.*/
- (id)attributeForKey:(NSString *)attributeKey{
//TODO
}

/*play

- (void)play
Discussion

Plays the movie.
Availability
Available in Mac OS X v10.3 and later.*/
- (void)play{
//TODO
}

/*movieFileTypes:

+ (NSArray *)movieFileTypes:(QTMovieTypeOptions)types
Discussion

Returns an array of file types that can be opened as QuickTime movies. Passing zero as the options parameter returns an array of all the common file types that QuickTime can open in place on the current system. This array includes the file type .mov and .mqv, and any files types that can be opened using a movie importer that does not need to write data into a new file while performing the import. This array excludes any file types for still images and any file types that require an aggressive movie importer (for instance, the movie importer for text files). The following values can be used to include some or all of the file types that are normally excluded:enum {
    QTIncludeStillImageTypes  =  1 << 0,
    QTIncludeTranslatableTypes =  1 << 1,
    QTIncludeAggressiveTypes =  1 << 2,
    QTIncludeCommonTypes = 0,
    QTIncludeAllTypes = 0xffff
} QTMovieFileTypeOptions;

Constants	
Description

QTIncludeStillImageTypes	
This value adds to the array all file types for still images that can be opened using a graphics importer.

QTIncludeTranslatableTypes	
This value adds to the array all file types for files that can be opened using a movie importer but for which a new file must be created.

QTIncludeAggressiveTypes	
This value adds to the array all file types for files that can be opened using a movie importer but that are not commonly used in connection with movies (for instance, text or HTML files).

QTIncludeCommonTypes	
This value adds to the array all common file types that QuickTime can open in place on the current system.

QTIncludeAllTypes	
This value adds to the array all file types that QuickTime can open on the current system, using any available movie or graphics importer.

Availability
Available in Mac OS X v10.3 and later.*/
+ (NSArray *)movieFileTypes:(QTMovieFileTypeOptions)types{}


/*movieWithURL:error:

+ (id)movieWithURL:(NSURL *)url error:(NSError **)errorPtr
Discussion

Creates a QTMovie object initialized with the data in the URL specified by url. 

If a QTMovie object cannot be created, an NSError object is returned in the location pointed to by errorPtr. Pass NIL if you do not want an NSError object returned.
Availability
Available in Mac OS X v10.3 and later.*/
+ (id)movieWithURL:(NSURL *)url error:(NSError **)errorPtr{}

@end
